#!/usr/bin/env python
# String functions

string = 'GTCA'
print string.replace('A','-') # => 'GTC-'
print string.lower() # => "gtca"
print string.upper() # => "GTCA"

# strings can also be treated like
# lists of characters (since they are)

# ['G','T','C','A']
#   0   1   2   3

# string[start:stop:step]
#   start - defalts to 0
#   stop - defaults to start+1, blank means the end of the list
#   step - defaults to 1 (use -1 to go backwards)
print string[0]   # 'G' first char
print string[:2]  # 'GT' first two chars
print string[1:3] # 'TC' 2rd and 3rd chars 
print string[-2:] # 'CA' last two chars
print string[::-1] # 'ACTG' Reverse a string
